# DirectoryScanner

Implements \SelectorScanner

Class for scanning a directory for files/directories that match a certain criteria.

These criteria consist of a set of include and exclude patterns. With these patterns, you can select which files you want to have included, and which files you want to have excluded.

The idea is simple. A given directory is recursively scanned for all files and directories. Each file/directory is matched against a set of include and exclude patterns. Only files/directories that match at least one pattern of the include pattern list, and don't match a pattern of the exclude pattern list will be placed in the list of files/directories found.

When no list of include patterns is supplied, "**" will be used, which means that everything will be matched. When no list of exclude patterns is supplied, an empty list is used, such that nothing will be excluded.

The pattern matching is done as follows: The name to be matched is split up in path segments. A path segment is the name of a directory or file, which is bounded by DIRECTORY_SEPARATOR ('/' under UNIX, '\' under Windows). E.g. "abc/def/ghi/xyz.php" is split up in the segments "abc", "def", "ghi" and "xyz.php". The same is done for the pattern against which should be matched.

Then the segments of the name and the pattern will be matched against each other. When '**' is used for a path segment in the pattern, then it matches zero or more path segments of the name.

There are special case regarding the use of DIRECTORY_SEPARATOR at the beginning of the pattern and the string to match: When a pattern starts with a DIRECTORY_SEPARATOR, the string to match must also start with a DIRECTORY_SEPARATOR. When a pattern does not start with a DIRECTORY_SEPARATOR, the string to match may not start with a DIRECTORY_SEPARATOR. When one of these rules is not obeyed, the string will not match.

When a name path segment is matched against a pattern path segment, the following special characters can be used: '*' matches zero or more characters, '?' matches one character.

Examples:

"*\.php" matches all .php files/dirs in a directory tree.

"test\a??.php" matches all files/dirs which start with an 'a', then two more characters and then ".php", in a directory called test.

"**" matches everything in a directory tree.

"\test\\XYZ*" matches all files/dirs that start with "XYZ" and where there is a parent directory called test (e.g. "abc\test\def\ghi\XYZ123").

Case sensitivity may be turned off if necessary. By default, it is turned on.

Example of usage: $ds = new DirectroyScanner(); $includes = array("*.php"); $excludes = array("modules*\"); $ds->SetIncludes($includes); $ds->SetExcludes($excludes); $ds->SetBasedir("test"); $ds->SetCaseSensitive(true); $ds->Scan();

print("FILES:"); $files = ds->GetIncludedFiles(); for ($i = 0; $i < count($files);$i++) { println("$files[$i]\n"); }

This will scan a directory called test for .php files, but excludes all .php files in all directories under a directory called "modules"

This class is complete preg/ereg free port of the Java class org.apache.tools.ant.DirectoryScanner. Even functions that use preg/ereg internally (like split()) are not used. Only the fast string functions and comparison operators (=== !=== etc) are used for matching and tokenizing.

author | Arnout J. Kuiper, ajkuiper@wxs.nl
author | Magesh Umasankar, umagesh@rediffmail.com
author | Andreas Aderhold, andi@binarycloud.com
version | $Id: cc81e1eb8ef44a36e9fcc01ff1ce3acc8933f3f3 $
package | phing.util

### Methods

## Adds the array with default exclusions to the current exclusions set.

    addDefaultExcludes()

## Tests whether a name matches the start of at least one include pattern.

    couldHoldIncluded(string $_name) : boolean

### Arguments

#### $_name

`string`

the name to match

### Response

`boolean`

`true` when the name matches against at least one include pattern, `false` otherwise.

## Gets the basedir that is used for scanning. This is the directory that is scanned recursively.

    getBasedir() : string

### Response

`string`

the basedir that is used for scanning

## <p>Returns the names of the directories which were selected out and therefore not ultimately included.</p>

    getDeselectedDirectories() : \the

The names are relative to the base directory. This involves performing a slow scan if one has not already been completed.

see | \#slowScan

### Response

`\the`

names of the directories which were deselected.

## <p>Returns the names of the files which were selected out and therefore not ultimately included.</p>

    getDeselectedFiles() : \the

The names are relative to the base directory. This involves performing a slow scan if one has not already been completed.

see | \#slowScan

### Response

`\the`

names of the files which were deselected.

## Get the names of the directories that matched at least one of the include patterns, an matched also at least one of the exclude patterns.

    getExcludedDirectories() : \the

The names are relative to the basedir.

### Response

`\the`

names of the directories

## Get the names of the files that matched at least one of the include patterns, an matched also at least one of the exclude patterns.

    getExcludedFiles() : \the

The names are relative to the basedir.

### Response

`\the`

names of the files

## Get the names of the directories that matched at least one of the include patterns, an matched none of the exclude patterns.

    getIncludedDirectories() : \the

The names are relative to the basedir.

### Response

`\the`

names of the directories

## Get the names of the files that matched at least one of the include patterns, and matched none of the exclude patterns.

    getIncludedFiles() : \the

The names are relative to the basedir.

### Response

`\the`

names of the files

## Get the names of the directories that matched at none of the include patterns.

    getNotIncludedDirectories() : \the

The names are relative to the basedir.

### Response

`\the`

names of the directories

## Get the names of the files that matched at none of the include patterns.

    getNotIncludedFiles() : \the

The names are relative to the basedir.

### Response

`\the`

names of the files

## Returns whether or not the scanner has included all the files or directories it has come across so far.

    isEverythingIncluded() : boolean

### Response

`boolean`

`true` if all files and directories which have

## Tests whether a name matches against at least one exclude pattern.

    isExcluded(string $_name) : boolean

### Arguments

#### $_name

`string`

the name to match

### Response

`boolean`

`true` when the name matches against at least one exclude pattern, `false` otherwise.

## Tests whether a name should be selected.

    isSelected(string $name, string $file) : boolean

### Arguments

#### $name

`string`

The filename to check for selecting.

#### $file

`string`

The full file path.

### Response

`boolean`

False when the selectors says that the file should not be selected, True otherwise.

## Lists contens of a given directory and returns array with entries

    listDir( $_dir) : array

author | Albert Lash, alash@plateauinnovation.com

### Arguments

#### $_dir

``

### Response

`array`

directory entries

## Matches a string against a pattern. The pattern contains two special characters: '*' which means zero or more characters, '?' which means one and only one character.

    match(string $pattern, string $str, boolean $isCaseSensitive = true) : boolean

### Arguments

#### $pattern

`string`

pattern to match against

#### $str

`string`

string that must be matched against the pattern

#### $isCaseSensitive

`boolean`

### Response

`boolean`

true when the string matches against the pattern, false otherwise.

## Matches a path against a pattern.

    matchPath(string $pattern, string $str, boolean $isCaseSensitive = true) : boolean

### Arguments

#### $pattern

`string`

the (non-null) pattern to match against

#### $str

`string`

the (non-null) string (path) to match

#### $isCaseSensitive

`boolean`

must a case sensitive match be done?

### Response

`boolean`

true when the pattern matches against the string. false otherwise.

## Scans the base directory for files that match at least one include pattern, and don't match any exclude patterns.

    scan()

## Sets the basedir for scanning. This is the directory that is scanned recursively. All '/' and '\' characters are replaced by DIRECTORY_SEPARATOR

    setBasedir( $_basedir)

### Arguments

#### $_basedir

``

## Sets the case sensitivity of the file system

    setCaseSensitive(boolean $_isCaseSensitive)

### Arguments

#### $_isCaseSensitive

`boolean`

specifies if the filesystem is case sensitive

## Sets whether to expand/dereference symbolic links

    setExpandSymbolicLinks(boolean $expandSymbolicLinks)

### Arguments

#### $expandSymbolicLinks

`boolean`

## Toplevel invocation for the scan.

    slowScan()

Returns immediately if a slow scan has already been requested.

### Properties

## default set of excludes

    DEFAULTEXCLUDES :

### Type(s)

``

## The base directory which should be scanned.

    basedir :

### Type(s)

``

## The patterns for the files that should be included.

    includes :

### Type(s)

``

## The patterns for the files that should be excluded.

    excludes :

### Type(s)

``

## Whether to expand/dereference symbolic links, default is false

    expandSymbolicLinks :

### Type(s)

``

## The files that where found and matched at least one includes, and matched no excludes.

    filesIncluded :

### Type(s)

``

## The files that where found and did not match any includes. Trie

    filesNotIncluded :

### Type(s)

``

## The files that where found and matched at least one includes, and also matched at least one excludes. Trie object.

    filesExcluded :

### Type(s)

``

## The directories that where found and matched at least one includes, and matched no excludes.

    dirsIncluded :

### Type(s)

``

## The directories that where found and did not match any includes.

    dirsNotIncluded :

### Type(s)

``

## The files that where found and matched at least one includes, and also matched at least one excludes.

    dirsExcluded :

### Type(s)

``

## Have the vars holding our results been built by a slow scan?

    haveSlowResults :

### Type(s)

``

## Should the file system be treated as a case sensitive one?

    isCaseSensitive :

### Type(s)

``

## Selectors

    selectors :

### Type(s)

``

## filesDeselected

    filesDeselected :

### Type(s)

``

## dirsDeselected

    dirsDeselected :

### Type(s)

``

## if there are no deselected files

    everythingIncluded :

### Type(s)

``